
import javax.media.opengl.GL;
import javax.media.opengl.GLAutoDrawable;
import com.sun.opengl.util.GLUT;
import java.awt.Color;
import javax.media.opengl.glu.GLU;
import com.sun.opengl.util.j2d.TextRenderer;
import com.sun.opengl.util.texture.Texture;
import com.sun.opengl.util.texture.TextureData;
import com.sun.opengl.util.texture.TextureIO;
import java.awt.Font;
import java.awt.Point;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import javax.imageio.ImageIO;
import javax.media.opengl.glu.GLUtessellator;
import javax.media.opengl.glu.GLUtessellatorCallbackAdapter;

public class Draw {

	int w, h;
	//->hardcoded
	private int fontHeight = 14;
	private static final float G_FONT_ASCENT = 119.05f;
	private static final float G_FONT_DESCENT = 33.33f;
	private static final float G_CHAR_WIDTH = 104.76f;
	public TextRenderer textRenderer = new TextRenderer(new Font("Time", Font.BOLD, 24), true, false, null, true);
	public TextRenderer textRenderer2 = new TextRenderer(new Font("Monospace", Font.BOLD, 12), true, false, null, true);
	JoglFramework framework = null;
	public GL gl = null;
	public GLUT glut = null;
	public GLU glu = null;
	private static final double DEG2RAD = 3.14159 / 180;

	public Draw(JoglFramework _jogl) {
		framework = _jogl;
	}

	public JoglFramework getFramework() {
		return framework;
	}

	public int getWidth() {
		return framework.width;
	}

	public int getHeight() {
		return framework.height;
	}

	public int getFPS() {
		return framework.height;
	}

	public void set(GLAutoDrawable drawable) {
		gl = drawable.getGL();
		glut = new GLUT();
		glu = new GLU();
		gl.setSwapInterval(0);
		gl.glEnable(GL.GL_POINT_SMOOTH);
		gl.glEnable(GL.GL_LINE_SMOOTH);
		gl.glHint(GL.GL_LINE_SMOOTH_HINT, GL.GL_FASTEST);
		gl.glDepthFunc(GL.GL_LESS);
		gl.glEnable(GL.GL_DEPTH_TEST);
		gl.glEnable(GL.GL_NORMALIZE);
	}

	public void init(GLAutoDrawable drawable) {

	}

	public GL getGlContext() {
		return gl;
	}

	//->to do
	/*public Vector3D getScreenCoordinates(Vector3D pos) {
	double[] screenCoord = new double[4];
	double[] model = new double[16];
	double[] projection = new double[16];
	int[] viewport = new int[4];
	gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX, model, 0);
	gl.glGetDoublev(GL.GL_PROJECTION_MATRIX, projection, 0);
	gl.glGetIntegerv(GL.GL_VIEWPORT, viewport, 0);
	float vX = pos.x();
	float vY = pos.y();
	glu.gluProject(vX, vY, 0f, model, 0, projection, 0, viewport, 0, screenCoord, 0);
	return new Vector3D((float) screenCoord[0], (float) screenCoord[1], (float) screenCoord[2]);
	}*/
	public void repaint() {
		framework.requestRedraw();
	}

	public void setBackground(float r, float g, float b) {
		gl.glClearColor(r, g, b, 0);
		gl.glClear(GL.GL_COLOR_BUFFER_BIT | GL.GL_DEPTH_BUFFER_BIT);
	}

	//-->to do
	public void resize(int _w, int _h) {
	}

	public void enableAlphaBlending(boolean bool) {
		if (bool == true) {
			//gl.glEnable(GL.GL_LINE_SMOOTH);
			gl.glDisable(GL.GL_DEPTH_TEST);
			gl.glEnable(GL.GL_ALPHA_TEST);
			gl.glEnable(GL.GL_BLEND);
			//gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE_MINUS_SRC_ALPHA);
			gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE);

			//gl.glBlendFunc(GL.GL_SRC_ALPHA, GL.GL_ONE);
		} else {
			gl.glEnable(GL.GL_DEPTH_TEST);
			gl.glDisable(GL.GL_LINE_SMOOTH);
			gl.glDisable(GL.GL_BLEND);
		}
	}

	public void enableLineStippling(boolean bool) {
		if (bool == true) {
			gl.glEnable(GL.GL_LINE_STIPPLE);
			gl.glLineStipple(2, (short) 0xAAAA);
		} else {
			gl.glDisable(GL.GL_LINE_STIPPLE);
		}
	}

	public void beginRotate(
					float rotationCenterX,
					float rotationCenterY,
					float rotationCenterZ,
					float angleX,
					float angleY,
					float angleZ) {
		gl.glPushMatrix();
		gl.glTranslatef(rotationCenterX, rotationCenterY, rotationCenterZ);
		gl.glRotatef(angleX, 1.0f, 0.0f, 0.0f);
		gl.glRotatef(angleY, 0.0f, 1.0f, 0.0f);
		gl.glRotatef(angleZ, 0.0f, 0.0f, 1.0f);
		gl.glTranslatef(-rotationCenterX, -rotationCenterY, -rotationCenterZ);
	}

	public void endRotate() {
		endTransform();
	}

	public void beginTranslate(
					float translationX,
					float translationY,
					float translationZ) {
		gl.glPushMatrix();
		gl.glTranslatef(translationX, translationY, translationZ);
	}

	public void endTranslate() {
		endTransform();
	}

	public void beginScale(
					float scaleX,
					float scaleY,
					float scaleZ) {
		gl.glPushMatrix();
		gl.glScalef(scaleX, scaleY, scaleZ);
	}

	public void endScale() {
		endTransform();
	}

	public void endTransform() {
		gl.glPopMatrix();
	}

	public void setColor(float r, float g, float b) {
		gl.glColor3f(r, g, b);
	}

	public void setColor(float r, float g, float b, float alpha) {
		gl.glColor4f(r, g, b, alpha);
	}

	public void setColor(Color c) {
		setColor(c.getRed() / 255.0f, c.getGreen() / 255.0f, c.getBlue() / 255.0f, c.getAlpha() / 255.0f);
	}

	public void setColor(Color c, float alpha) {
		setColor(c.getRed() / 255.0f, c.getGreen() / 255.0f, c.getBlue() / 255.0f, alpha);
	}

	public void setLineWidth(float width) {
		gl.glLineWidth(width);
	}

	public void drawLine(float x1, float y1, float x2, float y2) {
		gl.glBegin(GL.GL_LINES);
		gl.glVertex3f(x1, y1, 0);
		gl.glVertex3f(x2, y2, 0);
		gl.glEnd();
	}

	public void drawLine(float x1, float y1, float z1, float x2, float y2, float z2) {
		gl.glBegin(GL.GL_LINES);
		gl.glVertex3f(x1, y1, z1);
		gl.glVertex3f(x2, y2, z2);
		gl.glEnd();
	}

	public void drawPolyline(ArrayList points, boolean isClosed, boolean isFilled) {
		if (isFilled) {
			gl.glBegin(GL.GL_POLYGON);
		} else {
			gl.glBegin(isClosed ? GL.GL_LINE_LOOP : GL.GL_LINE_STRIP);
		}
		for (int i = 0; i < points.size(); ++i) {
			Vector2D p = (Vector2D) points.get(points.size() - i - 1);
			gl.glVertex2f((float) p.x(), (float) p.y());
		}
		gl.glEnd();
	}

	public void drawPolyline(ArrayList<Point> points, boolean isClosed) {
		drawPolyline(points, isClosed, false);
	}

	//to complete for drawing bezier curves
	//http://nehe.gamedev.net/data/lessons/lesson.asp?lesson=28
	Vector3D Bernstein(float u, Vector3D[] p) {
		Vector3D a, b, c, d, r;

		a = Vector3D.mult(p[0], (float) Math.pow(u, 3));
		b = Vector3D.mult(p[1], (float) (3 * Math.pow(u, 2) * (1 - u)));
		c = Vector3D.mult(p[2], (float) (3 * u * Math.pow(1 - u, 2)));
		d = Vector3D.mult(p[3], (float) Math.pow((1 - u), 3));

		r = Vector3D.sum(Vector3D.sum(a, b), Vector3D.sum(c, d));

		return r;
	}

	public void fillPolygon(ArrayList<Point> points) {
		drawPolyline(points, true, true);
	}

	public void drawPolyline3D(ArrayList points, boolean isClosed, boolean isFilled) {
		if (isFilled) {
			gl.glBegin(GL.GL_POLYGON);
		} else {
			gl.glBegin(isClosed ? GL.GL_LINE_LOOP : GL.GL_LINE_STRIP);
		}
		for (int i = 0; i < points.size(); ++i) {
			Vector3D p = (Vector3D) points.get(points.size() - i - 1);
			gl.glVertex3f((float) p.x(), (float) p.y(), (float) p.z());
		}
		gl.glEnd();
	}

	public void drawQuads(ArrayList points, boolean isClosed, boolean isFilled) {
		if (isFilled) {
			gl.glBegin(GL.GL_QUADS);
		} else {
			gl.glBegin(isClosed ? GL.GL_LINE_LOOP : GL.GL_LINE_STRIP);
		}
		for (int i = 0; i < points.size(); ++i) {
			Vector3D p = (Vector3D) points.get(points.size() - i - 1);
			gl.glVertex3f((float) p.x(), (float) p.y(), (float) p.z());
		}
		gl.glEnd();
	}

	public void drawQuadStrips(ArrayList points, boolean isClosed, boolean isFilled) {
		if (isFilled) {
			gl.glBegin(GL.GL_QUAD_STRIP);
		} else {
			gl.glBegin(isClosed ? GL.GL_LINE_LOOP : GL.GL_LINE_STRIP);
		}
		for (int i = 0; i < points.size(); ++i) {
			Vector3D p = (Vector3D) points.get(points.size() - i - 1);
			gl.glVertex3f((float) p.x(), (float) p.y(), (float) p.z());
		}
		gl.glEnd();
	}

	public void drawTriStrips(ArrayList points, boolean isClosed, boolean isFilled) {
		if (isFilled) {
			gl.glBegin(GL.GL_TRIANGLE_STRIP);
		} else {
			gl.glBegin(isClosed ? GL.GL_LINE_LOOP : GL.GL_LINE_STRIP);
		}
		for (int i = 0; i < points.size(); ++i) {
			Vector3D p = (Vector3D) points.get(points.size() - i - 1);
			gl.glVertex3f((float) p.x(), (float) p.y(), (float) p.z());
		}
		gl.glEnd();
	}

	public void drawTesselatePolyline(ArrayList<Vector3D> points) {
		GLUtessellator tess = glu.gluNewTess();
		//GLUtesselatorCallbackImpl tessCallback = new GLUtesselatorCallbackImpl(gl);
		Tesselator tessCallback = new Tesselator(gl);

		glu.gluTessCallback(tess, GLU.GLU_TESS_VERTEX, tessCallback);
		glu.gluTessCallback(tess, GLU.GLU_TESS_BEGIN, tessCallback);
		glu.gluTessCallback(tess, GLU.GLU_TESS_END, tessCallback);
		glu.gluTessCallback(tess, GLU.GLU_TESS_ERROR, tessCallback);
		glu.gluTessCallback(tess, GLU.GLU_TESS_COMBINE, tessCallback);

		glu.gluTessBeginPolygon(tess, null);
		glu.gluTessBeginContour(tess);
		for (int i = 0; i < points.size(); ++i) {
			Vector3D p = points.get(points.size() - i - 1);
			double[] pArray = {p.x(), p.y(), 0};
			glu.gluTessVertex(tess, pArray, 0, pArray);
		}
		glu.gluTessEndContour(tess);
		glu.gluTessEndPolygon(tess);

		gl.glDepthMask(true);
	}

	private class Tesselator extends GLUtessellatorCallbackAdapter {

		private GL gl;

		public Tesselator(GL gl) {
			this.gl = gl;
		}

		public void begin(int type) {
			gl.glBegin(type);
			//gl.glBegin(GL.GL_LINE_LOOP);
		}

		public void vertex(java.lang.Object vertexData) {
			double[] coords = (double[]) vertexData;
			gl.glVertex3dv(coords, 0);
		}

		public void end() {
			gl.glEnd();
		}
	}

	public void drawRect(float x, float y, float w, float h, boolean isFilled) {
		drawRect(x, y, 0, w, h, isFilled);
	}

	public void drawRect(float x, float y, float w, float h) {
		drawRect(x, y, 0, w, h, false);
	}

	public void fillRect(float x, float y, float w, float h) {
		drawRect(x, y, 0, w, h, true);
	}

  public void drawRect(float x, float y, float z, float w, float h, boolean isFilled) {
    if(isFilled){
      gl.glBegin(GL.GL_QUADS);
    }else{
      gl.glBegin(GL.GL_LINE_LOOP);
    }
		gl.glVertex3f(x, y, z);
		gl.glVertex3f(x, y + h, z);
		gl.glVertex3f(x + w, y + h, z);
		gl.glVertex3f(x + w, y, z);
		gl.glEnd();
	}

	void drawRectdBottomAligned(float x, float y, float w, float h) {
		drawRect(x, y - h, w, h);


	}

	public void drawCircle(float x, float y, float z, float radius, boolean isFilled) {
		x += radius;
		y += radius;
		if (isFilled) {
			gl.glBegin(GL.GL_TRIANGLE_FAN);
			gl.glVertex3f(x, y, z);
		} else {
			gl.glLineWidth(2);
			gl.glBegin(GL.GL_LINE_LOOP);
		}

		int numSides = (int) (2 * Math.PI * radius + 1);
		float deltaAngle = 2 * (float) Math.PI / numSides;

		for (int i = 0; i <= numSides; ++i) {
			float angle = i * deltaAngle;
			gl.glVertex3f(x + radius * (float) Math.cos(angle) + 0.5f, y + radius * (float) Math.sin(angle) + 0.5f, z);
		}
		gl.glEnd();
		gl.glLineWidth(1);

	}

	public void drawCircle(float x, float y, float radius) {
		drawCircle(x, y, 0, radius, false);
	}

	public void fillCircle(float x, float y, float radius) {
		drawCircle(x, y, 0, radius, true);
	}

	public void drawCenteredCircle(float x, float y, float radius, boolean isFilled) {
		x -= radius;
		y -= radius;
		drawCircle(x, y, 0, radius, isFilled);
	}

	public void drawCenteredCircle(float x, float y, float z, float radius, boolean isFilled) {
		x -= radius;
		y -= radius;
		drawCircle(x, y, z, radius, isFilled);
	}

	public void drawCenteredRect(float x, float y, float w, float h, boolean isFilled) {
		x -= w / 2;
		y -= h / 2;
		drawRect(x, y, w, h, isFilled);
	}

	//another version
	void drawCircle(float cx, float cy, float r, int num_segments) {
		gl.glBegin(GL.GL_LINE_LOOP);
		for (int i = 0; i < num_segments; i++) {
			float theta = 2.0f * 3.1415926f * (float) i / (float) num_segments;
			float x = r * (float) Math.cos(theta);
			float y = r * (float) Math.sin(theta);
			gl.glVertex2f(x + cx, y + cy);
		}
		gl.glEnd();
	}

	void drawEllipse(float cx, float cy, float cz, float xradius, float yradius,
					int resolutionDivider, boolean isFilled) {

		if (isFilled) {
			gl.glBegin(GL.GL_POLYGON);
		} else {
			gl.glBegin(GL.GL_LINE_LOOP);
		}
		for (int i = 0; i < 360 / resolutionDivider; i++) {
			//convert degrees into radians
			double degInRad = i * resolutionDivider * DEG2RAD;
			gl.glVertex3f((float) Math.cos(degInRad) * xradius + cx,
							(float) Math.sin(degInRad) * yradius + cy, cz);
		}
		gl.glEnd();
	}

	void drawEllipse(float cx, float cy, float xradius, float yradius,
					int resolutionDivider, boolean isFilled) {
		drawEllipse(cx, cy, 0, xradius, yradius, resolutionDivider, isFilled);

	}

	public void drawPoint(float x, float y, float z, float pointSize) {
		gl.glPointSize(pointSize);
		gl.glBegin(GL.GL_POINTS);
		gl.glVertex3f(x, y, z);
		gl.glEnd();
	}

	public void drawPoint(float x, float y, float pointSize) {
		drawPoint(x, y, 0, pointSize);
	}

	void drawFastBroadArc(float cx, float cy, float r, float start_angle, float arc_angle) {
		int num_segments = 10 * (int) Math.sqrt(r);
		float theta = arc_angle / (float) num_segments - 1;
		float tangential_factor = (float) Math.tan(theta);
		float radial_factor = (float) Math.cos(theta);
		float x = r * (float) Math.cos(start_angle);
		float y = r * (float) Math.sin(start_angle);
		gl.glBegin(GL.GL_LINE_STRIP);
		for (int ii = 0; ii < num_segments; ii++) {
			gl.glVertex2f(x + cx, y + cy);
			float tx = -y;
			float ty = x;
			x += tx * tangential_factor;
			y += ty * tangential_factor;
			x *= radial_factor;
			y *= radial_factor;
		}
		gl.glEnd();
	}

	public void drawArc(float x, float y, float radius, float startAngle, float stopAngle, boolean isFilled) {
		int numSides = (int) (2 * Math.PI * radius + 1);
		float deltaAngle = 2 * (float) Math.PI / numSides;
		if (isFilled) {
			gl.glBegin(GL.GL_POLYGON);
		} else {
			gl.glBegin(GL.GL_LINE_STRIP);
		}
		for (float angle = startAngle; angle < stopAngle; angle += deltaAngle) {
			gl.glVertex3f(x + radius * (float) Math.cos(angle), y + radius * (float) Math.sin(angle), 0f);
		}
		gl.glEnd();
	}

	public void drawPie(float x, float y, float radius, float startAngle, float stopAngle, boolean isFilled) {
		int numSides = (int) (2 * Math.PI * radius + 1);
		float deltaAngle = 2 * (float) Math.PI / numSides;
		if (isFilled) {
			gl.glBegin(GL.GL_POLYGON);
		} else {
			gl.glBegin(GL.GL_LINE_STRIP);
		}
		gl.glVertex3f(x, y, 0f);
		for (float angle = startAngle; angle < stopAngle; angle += deltaAngle) {
			gl.glVertex3f(x + radius * (float) Math.cos(angle), y + radius * (float) Math.sin(angle), 0f);
		}
		gl.glVertex3f(x, y, 0f);
		gl.glEnd();
	}

	public void drawPiePart(float x, float y, float radius, float innerRadius, float height, float bevel, float startAngle, float stopAngle, boolean isFilled) {
		int numSides = (int) (2 * Math.PI * radius + 1);
		//bevel = 0;
		float deltaAngle = 2 * (float) Math.PI / numSides;
		if (isFilled) {
			gl.glBegin(GL.GL_POLYGON);
		} else {
			gl.glBegin(GL.GL_LINE_LOOP);
		}
		for (float angle = startAngle; angle < stopAngle; angle += deltaAngle) {
			gl.glVertex3f(x + radius * (float) Math.cos(angle), y + radius * (float) Math.sin(angle), 0f);
		}
		for (float angle = stopAngle - deltaAngle * bevel; angle >= startAngle + deltaAngle * bevel; angle -= deltaAngle) {
			gl.glVertex3f(x + (radius - height) * (float) Math.cos(angle), y + (radius - height) * (float) Math.sin(angle), 0f);
		}
		gl.glEnd();
	}

	public float textWidth(String text) {
		Rectangle2D bounds = textRenderer.getBounds(text);
		return (float) bounds.getWidth();
	}

	public float textHeight(String text) {
		Rectangle2D bounds = textRenderer.getBounds(text);
		return (float) bounds.getHeight();
	}

	public void drawText2D(String text, int x, int y) {
		textRenderer.beginRendering(w, h);
		textRenderer.draw(text, x, y);
		//textRenderer.draw(text, (int)(getWidth()-convertFromPixelX(getWidth() - x)), (int)(getHeight()-convertFromPixelY(y)));
		//textRenderer.draw(text, (int) (getWidth() - getWidth() - x), (int) getHeight() - y);
		textRenderer.endRendering();
		textRenderer.flush();
	}

	public void drawText3D(String text, int x, int y, int z) {
		gl.glPushMatrix();
		gl.glTranslatef(x, y, z);

		gl.glScalef(1.0f, -1.0f, 1.0f);
		gl.glTranslatef(-x, -y, -z);
		gl.glPolygonMode(GL.GL_BACK, GL.GL_FILL);
		textRenderer.begin3DRendering();
		//Rectangle2D bounds1 = textRenderer.getBounds(text);
		//float text1W = (float) bounds1.getWidth();
		//float text1H = (float) bounds1.getHeight();
		textRenderer.draw3D(text, x, y, z, 1f);
		textRenderer.end3DRendering();
		textRenderer.flush();
		gl.glPopMatrix();
	}

	//-> complete the textrenderer choice
	public void drawText3D(String text, int textRendererNum, int x, int y, int z) {
		gl.glPushMatrix();
		gl.glTranslatef(x, y, z);

		gl.glScalef(1.0f, -1.0f, 1.0f);
		gl.glTranslatef(-x, -y, -z);
		gl.glPolygonMode(GL.GL_BACK, GL.GL_FILL);
		textRenderer2.begin3DRendering();
		textRenderer2.draw3D(text, x, y, z, 1f);
		textRenderer2.end3DRendering();
		textRenderer2.flush();
		gl.glPopMatrix();
	}

	void drawRotatedText3D(String text, int x, int y, int z, int rotX, int rotY, int rotZ) {
		gl.glPushMatrix();
		gl.glTranslatef(x, y, z);
		gl.glRotatef(rotX, 1.0f, 0.0f, 0.0f);
		gl.glRotatef(rotY, 0.0f, 1.0f, 0.0f);
		gl.glRotatef(rotZ, 0.0f, 0.0f, 1.0f);
		gl.glScalef(1.0f, -1.0f, 1.0f);
		gl.glTranslatef(-x, -y, -z);
		gl.glPolygonMode(GL.GL_BACK, GL.GL_FILL);
		textRenderer.begin3DRendering();
		//Rectangle2D bounds1 = textRenderer.getBounds(text);
		//float text1W = (float) bounds1.getWidth();
		//float text1H = (float) bounds1.getHeight();
		textRenderer.draw3D(text, x, y, z, 1f);
		textRenderer.end3DRendering();
		textRenderer.flush();
		gl.glPopMatrix();
	}

	public void setTextColor(Color color) {
		textRenderer.setColor(color);
	}

	public void setFontHeight(int h) {
		fontHeight = h;
	}

	public int getFontHeight() {
		return fontHeight;
	}

	// returns the width of a string
	public float stringWidth(String s) {
		if (s == null || s.length() == 0) {
			return 0;
		}

		float h, w_over_h;
		h = G_FONT_ASCENT /* + G_FONT_DESCENT + G_FONT_VERTICAL_SPACE */;
		w_over_h = G_CHAR_WIDTH / h;

		return fontHeight * s.length() * w_over_h;
	}

	//glut string drawing
	public void drawString(
					float x, float y, // lower left corner of the string
					String s // the string
					) {
		if (s == null || s.length() == 0) {
			return;
		}

		float ascent = fontHeight * G_FONT_ASCENT
						/ (G_FONT_ASCENT /* + G_FONT_DESCENT + G_FONT_VERTICAL_SPACE */);
		y += fontHeight - ascent;

		gl.glPushMatrix();
		gl.glTranslatef(x, y, 0);
		gl.glScalef(1, -1, 1); // to flip the y axis

		// We scale the text to make its height that desired by the caller.
		float sf = ascent / G_FONT_ASCENT; // scale factor
		gl.glScalef(sf, sf, 1);
		for (int j = 0; j < s.length(); ++j) {
			glut.glutStrokeCharacter(GLUT.STROKE_MONO_ROMAN, s.charAt(j));
		}
		gl.glPopMatrix();
	}
}
