
/**
 * Frankensteined from
 * http://libraries.seltar.org/postToWeb/
 */
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.stream.ImageOutputStream;
import javax.imageio.stream.MemoryCacheImageOutputStream;

public class ImageWebUploader {

	/**
	 * Get the image as a jpeg byte array
	 * @param image BufferedImage to create the byte array from
	 * @see BufferedImage
	 */
//	static byte[] getBytesJPEG(BufferedImage image) {
//		ByteArrayOutputStream baos = new ByteArrayOutputStream();
//
//		java.util.Iterator iter = ImageIO.getImageWritersByFormatName("jpeg");
//		if (iter.hasNext()) {
//			ImageWriter writer = (ImageWriter) iter.next();
//			ImageWriteParam iwp = writer.getDefaultWriteParam();
//			iwp.setCompressionMode(ImageWriteParam.MODE_EXPLICIT);
//			iwp.setCompressionQuality(1.0f);
//
//			ImageOutputStream ios = new MemoryCacheImageOutputStream(baos);
//			writer.setOutput(ios);
//			try {
//				writer.write(image);
//			} catch (Exception e) {
//				System.out.println(e);
//				return new byte[0]; // Problem
//			}
//			return baos.toByteArray();
//		}
//		return new byte[0];
//	}
	private byte[] obtainByteData(String filename) {
		InputStream inputStream = getClass().getResourceAsStream("/" + filename);
		ByteArrayOutputStream outputStream = new ByteArrayOutputStream(1024);
		byte[] bytes = new byte[512];

		// Read bytes from the input stream in bytes.length-sized chunks and write
		// them into the output stream
		int readBytes;
		try {
			while ((readBytes = inputStream.read(bytes)) > 0) {
				outputStream.write(bytes, 0, readBytes);
			}
			// Close the streams
			inputStream.close();
			outputStream.close();
		} catch (IOException ex) {
			System.out.println(ex);
		}

		// Convert the contents of the output stream into a byte array
		byte[] byteData = outputStream.toByteArray();

		return byteData;
	}


	/* Post function for remote saving
	Saves to a project folder
	Post the byte array to the given Url, with the given filename
	Pops up a browser window with a link to the file, if requested
	 */
	public void post(String project, String url, String filename) {
		byte[] bytes = obtainByteData(filename);

		String cType = "image/jpeg";
		String boundary = "|X-seltars-image-and-pdf-byte-array-uploader-X|";
		try {
			URL u = new URL(url);
			HttpURLConnection c = (HttpURLConnection) u.openConnection();

			// post multipart data
			c.setDoOutput(true);
			c.setDoInput(true);
			c.setUseCaches(false);

			// set request headers
			c.setRequestProperty("Content-Type", "multipart/form-data; boundary=" + boundary);

			// open a stream which can write to the url
			DataOutputStream dstream = new DataOutputStream(c.getOutputStream());

			// write content to the server, begin with the tag that says a content element is comming
			dstream.writeBytes("--" + boundary + "\r\n");

			// discribe the content
			dstream.writeBytes("Content-Disposition: form-data; name=\"" + project
							+ "\"; filename=\"" + filename + "\"\r\nContent-Type: " + cType
							+ "\r\nContent-Transfer-Encoding: binary\r\n\r\n");
			dstream.write(bytes, 0, bytes.length);

			// close the multipart form request
			dstream.writeBytes("\r\n--" + boundary + "--\r\n\r\n");
			dstream.flush();
			dstream.close();

			StringBuffer response = new StringBuffer();
			// read the output from the URL
			try {
				InputStreamReader inStream = new InputStreamReader(c.getInputStream());
				BufferedReader in = new BufferedReader(inStream);
				// Get the server response code
				int responseCode = -1;
				//try {
				responseCode = c.getResponseCode();
				//} catch (IOException ioe) {
				//}
				if (responseCode == 200) {
					// Everything has gone well so far
					// Get the server response
					String responseLine = null;
					do {
						responseLine = in.readLine();
						if (responseLine != null) {
							response.append(responseLine + "\n");
						}
					} while (responseLine != null);
					// output the response
					System.out.println("A: "+response.toString());
				}
			} catch (Exception e) {
				System.out.println("B: "+e);
			}
		} catch (Exception e) {
			System.out.println("C: "+e);
		}
	}
}
