
import java.util.ArrayList;
import java.util.HashMap;

public class Node {

  static HashMap<String, Object> attributesMax = new HashMap<String, Object>();
  public HashMap<String, Object> attributes = new HashMap<String, Object>();
  public ArrayList<Node> neighbours = new ArrayList<Node>();
  public ArrayList<NodeSet> nodeSets = new ArrayList<NodeSet>();
  public String label;
  public boolean showLabel = false;
  public String name;
  public float x = 0, y = 0; // position
  public float color_r = 0, color_g = 0, color_b = 0, alpha = 0.5f;
  // The NS_ prefix means "Node Shape"
  public static final int NS_CIRCLE = 0;
  public static final int NS_SQUARE = 1;
  public static final int NS_TRIANGLE = 2;
  public static final int NS_DIAMOND = 3;
  public static final int NUM_NODE_SHAPES = 4;
  public int nodeShape = NS_CIRCLE;
  public boolean isFixed = false;
  private boolean temporarilyHighlighted = false;
  /**
   * Used in the force-directed layout algorithms
   */
  public float forceX, forceY;
  public float weight = 1; // non-negative
  public float numberOfOtherNodes; // for temporary storage only
  public float sumOfWeightsOfOtherNodes; // for temporary storage only
  private int index = -1;
  //private int zLayerIndex = 0;

  public Node() {
  }

  public Node(String s) {
    label = s;
  }

  public Node(int _index) {
    index = _index;
  }

  public boolean isTemporarilyHighlighted() {
    return temporarilyHighlighted;
  }

  public void setTemporarilyHighlighted(boolean flag) {
    temporarilyHighlighted = flag;
  }

  public void setIndex(int i) {
    index = i;
  }

  // Note: the index returned here is not guaranteed to be correct.
  // Clients who want an index guaranteed to be correct
  // should call Network.getIndexOfNode()
  public int getIndex() {
    return index;
  }

  /*public int getZLayerIndex() {
  return zLayerIndex;
  }

  public void setZLayerIndex(int zli) {
  zLayerIndex = zli;
  }*/
}

