
import java.util.ArrayList;

public class NodeSet {

  public ArrayList<Node> nodes = new ArrayList<Node>();

  public int size() {
    return nodes.size();
  }

  public boolean contains(Node n) {
    assert nodes.contains(n) == n.nodeSets.contains(this);
    return n.nodeSets.contains(this);
  }

  public void addNode(Node n) {
    if (!contains(n)) {
      nodes.add(n);
      assert !n.nodeSets.contains(this);
      n.nodeSets.add(this);
    }
  }

  public void addNodes(ArrayList<Node> newNodes) {
    for (int i = 0; i < newNodes.size(); ++i) {
      Node n = newNodes.get(i);
      addNode(n);
    }
  }

  public void removeNode(Node n) {
    n.nodeSets.remove(this);
    nodes.remove(n);
  }

  public void clear() {
    for (int i = nodes.size() - 1; i >= 0; --i) {
      nodes.get(i).nodeSets.remove(this);
    }
    nodes.clear();
  }

  public boolean isSubsetOf(NodeSet otherSet) {
    if (otherSet.size() < nodes.size()) {
      return false;
    }
    for (int i = 0; i < nodes.size(); ++i) {
      Node n = nodes.get(i);
      if (!otherSet.contains(n)) {
        return false;
      }
    }
    return true;
  }

  public boolean isEqualTo(NodeSet otherSet) {
    if (nodes.size() != otherSet.size()) {
      return false;
    }
    // We know the two sets have the same size.
    // Therefore, is one is a subset of the other,
    // then they are equal.
    return isSubsetOf(otherSet);
  }
}




