
public class Rect2D {

  public boolean isEmpty = true;
  private Vector2D min = new Vector2D(0, 0);
  private Vector2D max = new Vector2D(0, 0);

  public Rect2D() {
  }

  public Rect2D(Vector2D p0, Vector2D p1) {
    min.copy(p0);
    max.copy(p1);
    isEmpty = false;
  }

  public void clear() {
    isEmpty = true;
  }

  public void bound(Vector2D v) {
    if (isEmpty) {
      min.copy(v);
      max.copy(v);
      isEmpty = false;
    } else {
      if (v.x() < min.x()) {
        min.v[0] = v.x();
      } else if (v.x() > max.x()) {
        max.v[0] = v.x();
      }

      if (v.y() < min.y()) {
        min.v[1] = v.y();
      } else if (v.y() > max.y()) {
        max.v[1] = v.y();
      }
    }
  }

  public boolean isEmpty() {
    return isEmpty;
  }

  public boolean contains(Vector2D p) {
    return !isEmpty
            && min.x() <= p.x() && p.x() <= max.x()
            && min.y() <= p.y() && p.y() <= max.y();
  }

  public Vector2D getMin() {
    return min;
  }

  public Vector2D getMax() {
    return max;
  }

  public Vector2D getDiagonal() {
    return Vector2D.diff(max, min);
  }

  public Vector2D getCentre() {
    return Vector2D.mult(Vector2D.sum(min, max), 0.5f);
  }
}

