
import java.awt.Color;
import javax.media.opengl.GLCapabilities;

public class Window extends JoglFramework {

	FlockingDisplay flock;
	SupershapeDisplay supershape;
	SoundController soundCtrl;
	int rotX = 21;
	int rotY = 162;
	boolean mouseWasClicked = false;
	ImageWebUploader imgUploader = new ImageWebUploader();

	Window(GLCapabilities caps) {
		super(caps);
		soundCtrl = new SoundController(this, draw);
		flock = new FlockingDisplay(this, draw);
		supershape = new SupershapeDisplay(this, draw);
	}

	public void draw() {
		draw.setBackground(0f, 0f, 0f);

		soundCtrl.draw();
		flock.draw();
		flock.drawPlanisphere(soundCtrl.getFeatures());
		supershape.draw();

		////display text
		//draw.textRenderer2.setColor(Color.lightGray);
		//draw.drawText3D("fps: " + getFPS(), 2, 70, height - 50, 0);
//
//		if (mouseWasClicked) {
//			//Screenshotter.takeTargaScreenshot(draw, "capture.tga");
//			String fileName = "capture.jpg";
//			//String url = "http://christopheviau.com/genoma/genoma_labs_server/upload.php";
//			String url = "http://localhost:8888/genoma_labs_server/upload.php";
//			Screenshotter.takeScreenshot(draw, "./src/"+fileName, 700, 300, Config.width-1400, Config.height-600);
//			imgUploader.post("screenshots", url, fileName);
//			mouseWasClicked = false;
//		}

	}

	void onCursorMove(Cursor cursor) {
	}

	void onCursorPress(Cursor cursor) {
		mouseWasClicked = true;
	}

	void onCursorRelease(Cursor cursor) {
	}

	void onCursorDrag(Cursor cursor) {
		flock.onCursorDrag(cursor);
		supershape.onCursorDrag(cursor);
		//rotY += cursor.prevX - cursor.x;
		//rotX -= cursor.prevY - cursor.y;
	}

	void onCursorClick(Cursor cursor) {
	}
}
